#########################################################
# Patch to log WebDAV related requests and responses
# Published under the Zope Public License
# Written by Andreas Jung
#########################################################


import ZServer.HTTPResponse
import ZServer.HTTPServer
from ZServer.PubCore.ZEvent import Wakeup 
import thread,re,os,time
from types import StringType
from zLOG import LOG,INFO

# Path to logfile

try:
    logFile = os.path.join(globals()["__builtins__"]["CLIENT_HOME"],\
            'webdav_debug.log')
except:
    logFile = os.path.join(os.getcwd(),'webdav_debug.log')

LOG("WebDAVLogger",INFO,"enabled, Logfile: %s" % logFile)

lock = thread.allocate_lock()
pat = re.compile("content-type:.*text/xml",re.I)

ts = time.time()

def _log(text,what=''):
    global ts


    if not isinstance(text,StringType): 
        text = '...binary data ....' 
    else:
        if not pat.search(text): return 

    lock.acquire()

    try:
        diff =time.time() -ts
        ts = time.time()
        fp = open(logFile,'a')
        fp.write('\n' + '-'*78 + '\n') 
        fp.write('%s:   ' % what)
        fp.write('Timediff: %6.4f seconds\n\n' % diff)
        fp.write(text)
        fp.write('\n')
        fp.close()
    finally:
        lock.release()


def mywrite(self, text, l=None):
    if self._channel.closed:
        return
    if l is None: l=len(text)
    self._bytes=self._bytes + l

    _log(text, "Response")

    self._channel.push(text,0)
    Wakeup()
      

def myfound_terminator(self):

    # reset collector
    self.request.channel.set_terminator('\r\n\r\n')
    self.request.collector=None
    # finish request
    self.data.seek(0)
    s = self.request.request + '\n'
    s = s + "\n".join(self.request.header)
    s = s + "\n\n"+ self.data.read()
    _log(s,"Request")
    self.data.seek(0)
    r=self.request
    d=self.data
    del self.request
    del self.data
    self.handler.continue_request(d,r)


ZServer.HTTPResponse.ChannelPipe.write              = mywrite  
ZServer.HTTPServer.zhttp_collector.found_terminator = myfound_terminator
